/*
 * HotInt specific configuration.
 * 
 * $LastChangedRevision: 651 $
 *
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
 * All rights reserved.
 */
#ifndef __HOTINT_H__
#define __HOTINT_H__

#include "X2cDataTypes.h"
#include "TcpIpRoutines.h"

/* public prototypes */
void initPortArray(void);

/* Receives status flag and inport values in the negotiated order */
uint8 receiveInportValues(TCPIPSocket* socket, uint32* statusFlag);
/* Sends status flag and outport values in the negotiated order */
uint8 sendOutportValues(TCPIPSocket* socket, uint32* statusFlag);
/* sends update interval time */
uint8 sendUpdateIntervalTime(TCPIPSocket* socket, double time);
/* Receives inport order and sets link table */
uint8 setInportOrder(TCPIPSocket* socket);
/* Receives outport order and sets link table */
uint8 setOutportOrder(TCPIPSocket* socket);
/* Returns update interval */
float64 getUpdateInterval(void);

#endif
